#ifndef WAFER_H
#define WAFER_H
#pragma once
#include <QWidget>
#include <vector>
#include <QMenu>
#include "WaferGraphicsView.h"
#include "DieItem.h"
#include "CInterface.h"
enum OperateMode {
    ModeImage,  // 显示图片
    ModeView    // 显示 view
};

class Wafer : public QWidget
{
    Q_OBJECT

public:
    explicit Wafer(int flag, QWidget *parent = nullptr);

    void initFrom(QWidget *parent);
    void paintInitFrom(QWidget *parent);
    QPixmap getGlobalPixmap() const;

    QColor getColorByStatus(PICK_DIE_STATUS status);
    QGraphicsScene* scene;
    WaferGraphicsView *view;

protected:

private slots:

signals:
    void sendCoordinates(int x, int y);

private:
    int Flag;
    QVector<WAFER_MATRIX_POINT_INFO_STRUCT> waferData;
    int rows, cols;
    int centerX, centerY;
    qreal radius;
    QMenu *contextMenu = nullptr;
    QPixmap globalPixmap;
};

#endif // WAFER_H
