#ifndef WAFFLE_H
#define WAFFLE_H
#pragma once
#include "CInterface.h"
#include <QWidget>
#include <vector>
#include <QMenu>
#include "WaffleGraphicsView.h"
#include "DieItem.h"
class Waffle : public QWidget
{
public:
    Waffle(int flag, QWidget *parent = nullptr);


    void paintEvent(QPaintEvent *event) override;
    QColor getColorByStatus(PICK_DIE_STATUS status);
    void initFrom(QWidget *parent);
    void paintInitFrom(QWidget *parent);
    QPixmap getGlobalPixmap() const;
    QGraphicsScene* scene;
    WaffleGraphicsView *view;
protected:
private:
    void drawWaffle(QPainter &painter, int startX, int startY, int rows, int cols, int gridSize, int gap);

    // 华夫台的参数
    int gridSize;  // 每个格子的大小
    int gap;        // 格子之间的间隙
    int rows = 3;       // 华夫台的行数
    int cols = 3;       // 华夫台的列数

    // 华夫盒的参数
    int boxRows = 3;    // 华夫盒的行数
    int boxCols = 4;    // 华夫盒的列数
    int boxGap;    // 华夫台之间的间隙
    QVector<WAFFLE_MATRIX_POINT_STRUCT> waffleData;
    int centerX, centerY;
    QPixmap globalPixmap;
};

#endif // WAFFLE_H
