﻿#include "MainAndSecondaryCamerasWnd.h"
#include "ui_MainAndSecondaryCamerasWnd.h"
#include <QSettings>
#include <QCloseEvent>
#include <QVBoxLayout>
#include <QTimer>
#include "CameraMaterialGroupWnd/CameraImage/CameraImageHandler.h"
#include <qDebug.h>
#include <QScrollBar>

MainAndSecondaryCamerasWnd::MainAndSecondaryCamerasWnd(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainAndSecondaryCamerasWnd)
{
    ui->setupUi(this);

    QSettings settings("YourOrganization", "YourApplication");
    settings.beginGroup("LastSettings");
    lastRightPixmap = settings.value("LastRightPixmap").value<QPixmap>();
    lasttextList = settings.value("LasttextList").toStringList();
    lastLastRightPixmap = settings.value("LastLastRightPixmap").value<QPixmap>();
    lastLasttextList = settings.value("LastLasttextList").toStringList();
    lastLastIndex = settings.value("LastLastIndex", 0).toInt();
    lastLastGroupId = settings.value("LastLastGroupId", 0).toInt();
    settings.endGroup();

    initFrom();
    isShow_R = true;
    isShow_L = true;
}

MainAndSecondaryCamerasWnd::~MainAndSecondaryCamerasWnd()
{
    delete ui;
}

void MainAndSecondaryCamerasWnd::initFrom()
{

    QTimer *timer = new QTimer(this);
    connect(timer, &QTimer::timeout, this, &MainAndSecondaryCamerasWnd::checkSettings);
    timer->start(100);

    ui->Leftlabel_Percentage->setAlignment(Qt::AlignCenter);
    ui->Rightlabel_Percentage->setAlignment(Qt::AlignCenter);

    initSliders();
    initLineEdits();
	initProgressBar();
    // 连接 QSlider 的 valueChanged 信号到 QProgressBar 的 setValue 槽
    connect(ui->RedLightverticalSlider_2, &QSlider::valueChanged, ui->RedLightprogressBar_2, &QProgressBar::setValue);
    connect(ui->BlueLightverticalSlider, &QSlider::valueChanged, ui->BlueLightprogressBar_2, &QProgressBar::setValue);
    connect(ui->GreenLightverticalSlider_5, &QSlider::valueChanged, ui->GreenLightprogressBar_5, &QProgressBar::setValue);
    connect(ui->DotLightverticalSlider_2, &QSlider::valueChanged, ui->DotLightprogressBar_2, &QProgressBar::setValue);

    connect(ui->RedLightverticalSlider_L, &QSlider::valueChanged, ui->RedLightprogressBar_L, &QProgressBar::setValue);
    connect(ui->BlueLightverticalSlider_L, &QSlider::valueChanged, ui->BlueLightprogressBar_L, &QProgressBar::setValue);
    connect(ui->GreenLightverticalSlider_L, &QSlider::valueChanged, ui->GreenLightprogressBar_L, &QProgressBar::setValue);
    connect(ui->DotLightverticalSlider_L, &QSlider::valueChanged, ui->DotLightprogressBar_L, &QProgressBar::setValue);

    connectSliderAndLineEdit(ui->RedLightverticalSlider_2, ui->RedLightlineEdit_2);
    connectSliderAndLineEdit(ui->GreenLightverticalSlider_5, ui->GreenLightlineEdit_5);
    connectSliderAndLineEdit(ui->BlueLightverticalSlider, ui->BlueLightlineEdit_2);
    connectSliderAndLineEdit(ui->DotLightverticalSlider_2, ui->DotLightlineEdit_2);

    connectSliderAndLineEdit(ui->RedLightverticalSlider_L, ui->RedLightlineEdit_L);
    connectSliderAndLineEdit(ui->GreenLightverticalSlider_L, ui->GreenLightlineEdit_L);
    connectSliderAndLineEdit(ui->BlueLightverticalSlider_L, ui->BlueLightlineEdit_L);
    connectSliderAndLineEdit(ui->DotLightverticalSlider_L, ui->DotLightlineEdit_L);

    connect(ui->LeftOperatewidget,&ImageWidget::sendDoubleClicksignal,this,&MainAndSecondaryCamerasWnd::handleDoubleClick);
    connect(ui->RightOperatewidget,&ImageWidget::sendDoubleClicksignal,this,&MainAndSecondaryCamerasWnd::handleDoubleClick);
    QWidget *viewport = ui->scrollArea->viewport();
    QWidget *container = new QWidget(viewport);
    QHBoxLayout *mainLayout = new QHBoxLayout(container);

    mainLayout->setSpacing(28);
    mainLayout->setMargin(0);

    QList<int> numbers = {1, 2, 3, 4, 5, 6, 7, 8};

    QList<Group*> widgets;

    for (int i = 0; i < numbers.size(); ++i) {
        int num = numbers[i];
        CameraImageHandler* manager = new CameraImageHandler(num);
        Group* widget = manager->getGroup();
        connect(widget,&Group::send_button_Signal,this,&MainAndSecondaryCamerasWnd::CheckIs);
        if (widget != nullptr) {
            mainLayout->addWidget(widget);
            widgets.append(widget);
        }
        if(manager->getWafer()) {
            waferMap.insert(num, manager->getWafer());
        }
        if(manager->getWafer()) {
            waffleMap.insert(num, manager->getWaffle());
        }
        if(manager->getMaterialBox()){
            materialBoxMap.insert(num,manager->getMaterialBox());
        }

        delete manager;
    }

    // 设置控件的最小高度和最大宽度
    int minHeight = 162;
    int maxWidth = 244;
    int num = -28;
    for (Group* w : widgets) {
        w->setMinimumHeight(minHeight);
        w->setMaximumWidth(maxWidth);
        num = num + 272;
    }

    container->setMinimumSize(num, 162);
    container->setLayout(mainLayout);
    ui->scrollArea->setWidget(container);
    ui->scrollArea->resize(1062, 177);

    ui->LeftOperatewidget->setMouseTracking(true);
    ui->RightOperatewidget->setMouseTracking(true);

    QSettings settings2("YourOrganization", "YourApplication_lastWndType");
    int lastWndType = settings2.value("LastWndType").toInt();
    int LastGroup = settings2.value("LastGroup").toInt();
    lastIndex = lastWndType;
    lastGroupId = LastGroup;
}

void MainAndSecondaryCamerasWnd::initSliders() {
    QList<QSlider*> sliders = {
        ui->RedLightverticalSlider_2, ui->GreenLightverticalSlider_5,
        ui->BlueLightverticalSlider, ui->DotLightverticalSlider_2,
        ui->RedLightverticalSlider_L, ui->GreenLightverticalSlider_L,
        ui->BlueLightverticalSlider_L, ui->DotLightverticalSlider_L
    };
    QList<int> initialValues = {22, 11, 0, 0, 22, 11, 0, 0};

    for (int i = 0; i < sliders.size(); ++i) {
        sliders[i]->setMinimum(0);
        sliders[i]->setMaximum(100);
        sliders[i]->setValue(initialValues[i]);
    }
}
void MainAndSecondaryCamerasWnd::initProgressBar(){
    QList<int> initialValues = {22, 11, 0, 0, 22, 11, 0, 0};
    QList<QProgressBar*> progressBar = {
        ui->RedLightprogressBar_2,ui->GreenLightprogressBar_5,
        ui->BlueLightprogressBar_2,ui->DotLightprogressBar_2,
        ui->RedLightprogressBar_L,ui->GreenLightprogressBar_L,
        ui->BlueLightprogressBar_L,ui->DotLightprogressBar_L
    };
    for (int i = 0; i < progressBar.size(); ++i) {
        progressBar[i]->setMinimum(0);
        progressBar[i]->setMaximum(100);
        progressBar[i]->setValue(initialValues[i]);
    }
}

void MainAndSecondaryCamerasWnd::handleDoubleClick(){
    QPoint globalMousePos = QCursor::pos();  // 获取当前鼠标的全局位置
    QPoint leftWidgetLocalPos = ui->LeftOperatewidget->mapFromGlobal(globalMousePos);
    QPoint rightWidgetLocalPos = ui->RightOperatewidget->mapFromGlobal(globalMousePos);
    if (ui->LeftOperatewidget->rect().contains(leftWidgetLocalPos)){
        if (Left_currentMode == ModeImage) {
            QPixmap scaledImage = Left_currentPixmap.scaled(Left_currentPixmap.width(), Left_currentPixmap.height(), Qt::KeepAspectRatio, Qt::SmoothTransformation);
            ui->LeftOperatewidget->setPixmap(scaledImage); // 这里传递缩放后的图片
        } else if (Left_currentMode == ModeView && Left_currentView) {
            QTransform transform;
            transform.scale(1, 1);
            Left_currentView->setTransform(transform);
        }
        Left_scaleFactor = 1.0;
        Left_previousScaleFactor = 1.0;
        ui->Leftlabel_Percentage->setText("100%");
    }
    if(ui->RightOperatewidget->rect().contains(rightWidgetLocalPos)){
        if (Right_currentMode == ModeImage) {
            QPixmap scaledImage = Right_currentPixmap.scaled(Right_currentPixmap.width(), Right_currentPixmap.height(), Qt::KeepAspectRatio, Qt::SmoothTransformation);
            ui->RightOperatewidget->setPixmap(scaledImage); // 这里传递缩放后的图片
        } else if (Right_currentMode == ModeView && Right_currentView) {
            QTransform transform;
            transform.scale(1, 1);
            Right_currentView->setTransform(transform);
        }
        Right_scaleFactor = 1.0;
        Right_previousScaleFactor = 1.0;
        ui->Rightlabel_Percentage->setText("100%");
    }


}

void MainAndSecondaryCamerasWnd::initLineEdits() {
    QList<QLineEdit*> lineEdits = {
        ui->RedLightlineEdit_2, ui->GreenLightlineEdit_5,
        ui->BlueLightlineEdit_2, ui->DotLightlineEdit_2,
        ui->RedLightlineEdit_L, ui->GreenLightlineEdit_L,
        ui->BlueLightlineEdit_L, ui->DotLightlineEdit_L
    };

    for (QLineEdit* lineEdit : lineEdits) {
        lineEdit->setAlignment(Qt::AlignCenter);
    }
}

void MainAndSecondaryCamerasWnd::connectSliderAndLineEdit(QSlider* slider, QLineEdit* lineEdit)
{
    QIntValidator* validator = new QIntValidator(slider->minimum(), slider->maximum(), lineEdit);
    lineEdit->setValidator(validator);

    connect(slider, &QSlider::valueChanged, [lineEdit](int value) {
        lineEdit->setText(QString::number(value));
    });

    connect(lineEdit, &QLineEdit::textChanged, [slider](const QString &text) {
        bool ok;
        int value = text.toInt(&ok);
        if (ok && value >= slider->minimum() && value <= slider->maximum()) {
            slider->setValue(value);
        } else if (!text.isEmpty()) {
            int closestValue = qMin(qMax(text.toInt(&ok), slider->minimum()), slider->maximum());
            slider->setValue(closestValue);
        }
    });
}

void MainAndSecondaryCamerasWnd::checkSettings() {
    QSettings settings("YourCompany", "YourApplication_");
    int groupId = settings.value("GroupId", 0).toInt();
    int index = settings.value("Index", 0).toInt();

    if (groupId != lastGroupId || index != lastIndex) {
        loadSettings();
        lastGroupId = groupId;
        lastIndex = index;
    }
}

void MainAndSecondaryCamerasWnd::loadSettings()
{
    QSettings settings("YourCompany", "YourApplication_");
    int groupId = settings.value("GroupId", 0).toInt();
    int index = settings.value("Index", 0).toInt();
    loadGroupSettings(groupId, index);
}

void MainAndSecondaryCamerasWnd::loadGroupSettings(int Id, int Index) {
    // isUpdatingSettings = true;
    QSettings settings("YourOrganization", "YourApplication");
    settings.beginGroup(QString::number(Id));
    QString imagePath1 = settings.value("ImagePath1").toString();
    int materialWndType = settings.value("MaterialWndType").toInt();
    QStringList textList = settings.value("TextList").toStringList();
    settings.endGroup();
    QSettings Last_settings("YourOrganization", "YourApplication");
    settings.beginGroup(QString::number(lastGroupId));
    QString Last_imagePath1 = settings.value("ImagePath1").toString();
    int Last_materialWndType = settings.value("MaterialWndType").toInt();
    QStringList Last_textList = settings.value("TextList").toStringList();
    settings.endGroup();
    // QString lastRightImage = settings.value("LastRightImage").toString();

    QSize size_left = ui->LeftOperatewidget->size();
    QSize size_right = ui->RightOperatewidget->size();

    QPixmap newPixmap;
	QPixmap Last_newPixmap;

    if (Index == 1) {
        isShow_R = true;
        clearLayout(1);
        clearLayout(0);
        qDebug()<<imagePath1;
        newPixmap = QPixmap(imagePath1);
        QPixmap scaledPixmap = newPixmap.scaled(size_right, Qt::KeepAspectRatio, Qt::SmoothTransformation);
        Right_currentMode = ModeImage;
        Right_currentPixmap = scaledPixmap;
        Right_scaleFactor = 1.0;
        Right_previousScaleFactor = 1.0;
        ui->RightOperatewidget->setPixmap(scaledPixmap);
        double percentage = Right_scaleFactor * 100;
        QString percentageStr = QString::number((int)percentage);
        ui->Rightlabel_Percentage->setText(QString("%1%").arg(percentageStr));
        applyScale(1);
        // imageWidget(imagePath1,current_right,size_right);

        if (lastIndex == 1) {
            isShow_L = true;
            Last_newPixmap = QPixmap(Last_imagePath1);
            QPixmap scaledPixmap = Last_newPixmap.scaled(size_left, Qt::KeepAspectRatio, Qt::SmoothTransformation);
            Left_currentMode = ModeImage;
            Left_currentPixmap = scaledPixmap;
            Left_scaleFactor = 1.0;
            Left_previousScaleFactor = 1.0;
            ui->LeftOperatewidget->setPixmap(scaledPixmap);
            double percentage = Left_scaleFactor * 100;
            QString percentageStr = QString::number((int)percentage);
            ui->Leftlabel_Percentage->setText(QString("%1%").arg(percentageStr));
            // imageWidget(Last_imagePath1,last_left,size_left);

        } else if (lastIndex == 2) {
            isShow_L = false;
            // clearLayout(0);
            if (Last_materialWndType == 1) {

                KindsofWidget(last_left,lastGroupId,wafer_kind);

            } else if (Last_materialWndType == 2) {

                KindsofWidget(last_left,lastGroupId,waffle_kind);

            } else if (Last_materialWndType == 3) {

                KindsofWidget(last_left,lastGroupId,materialbox_kind);

            }
        }
    } else if (Index == 2) {
        isShow_R = false;
        clearLayout(1);
        clearLayout(0);

        if (lastIndex == 1) {
            // clearLayout(0);
            Last_newPixmap = QPixmap(Last_imagePath1);
            QPixmap scaledPixmap = Last_newPixmap.scaled(size_left, Qt::KeepAspectRatio, Qt::SmoothTransformation);
            Left_currentMode = ModeImage;
            Left_currentPixmap = scaledPixmap;
            Left_scaleFactor = 1.0;
            Left_previousScaleFactor = 1.0;
            ui->LeftOperatewidget->setPixmap(scaledPixmap);
            double percentage = Left_scaleFactor * 100;
            QString percentageStr = QString::number((int)percentage);
            ui->Leftlabel_Percentage->setText(QString("%1%").arg(percentageStr));
            isShow_L = true;
        }

        if (materialWndType == 1) {
		
            if (lastIndex == 1) {
                Last_newPixmap = QPixmap(Last_imagePath1);
                QPixmap scaledPixmap = Last_newPixmap.scaled(size_left, Qt::KeepAspectRatio, Qt::SmoothTransformation);
                Left_currentMode = ModeImage;
                Left_currentPixmap = scaledPixmap;
                Left_scaleFactor = 1.0;
                Left_previousScaleFactor = 1.0;
                ui->LeftOperatewidget->setPixmap(scaledPixmap);
                double percentage = Left_scaleFactor * 100;
                QString percentageStr = QString::number((int)percentage);
                ui->Leftlabel_Percentage->setText(QString("%1%").arg(percentageStr));
            } else if (lastIndex == 2) {
				isShow_L = false;
                // clearLayout(0);
                if (Last_materialWndType == 1) {

                    KindsofWidget(last_left,lastGroupId,wafer_kind);

                } else if (Last_materialWndType == 2) {

                    KindsofWidget(last_left,lastGroupId,waffle_kind);

                } else if (Last_materialWndType == 3) {

                    KindsofWidget(last_left,lastGroupId,materialbox_kind);

                }
            }

            KindsofWidget(current_right,Id,wafer_kind);

        } else if (materialWndType == 2) {
            if (lastIndex == 1) {
                Last_newPixmap = QPixmap(Last_imagePath1);
                QPixmap scaledPixmap = Last_newPixmap.scaled(size_left, Qt::KeepAspectRatio, Qt::SmoothTransformation);
                Left_currentMode = ModeImage;
                Left_currentPixmap = scaledPixmap;
                Left_scaleFactor = 1.0;
                Left_previousScaleFactor = 1.0;
                ui->LeftOperatewidget->setPixmap(scaledPixmap);
                double percentage = Left_scaleFactor * 100;
                QString percentageStr = QString::number((int)percentage);
                ui->Leftlabel_Percentage->setText(QString("%1%").arg(percentageStr));
            } else if (lastIndex == 2) {
				isShow_L = false;
                if (Last_materialWndType == 1) {

                    KindsofWidget(last_left,lastGroupId,wafer_kind);

                } else if (Last_materialWndType == 2) {                   

                    KindsofWidget(last_left,lastGroupId,waffle_kind);

                } else if (Last_materialWndType == 3) {

                    KindsofWidget(last_left,lastGroupId,materialbox_kind);

                }
            }

            KindsofWidget(current_right,Id,waffle_kind);

        } else if (materialWndType == 3) {
            if (lastIndex == 1) {
                Last_newPixmap = QPixmap(Last_imagePath1);
                QPixmap scaledPixmap = Last_newPixmap.scaled(size_left, Qt::KeepAspectRatio, Qt::SmoothTransformation);
                Left_currentMode = ModeImage;
                Left_currentPixmap = scaledPixmap;
                Left_scaleFactor = 1.0;
                Left_previousScaleFactor = 1.0;
                ui->LeftOperatewidget->setPixmap(scaledPixmap);
                double percentage = Left_scaleFactor * 100;
                QString percentageStr = QString::number((int)percentage);
                ui->Leftlabel_Percentage->setText(QString("%1%").arg(percentageStr));
            } else if (lastIndex == 2) {
				isShow_L = false;
                if (Last_materialWndType == 1) {

                    KindsofWidget(last_left,lastGroupId,wafer_kind);

                } else if (Last_materialWndType == 2) {

                    KindsofWidget(last_left,lastGroupId,waffle_kind);

                } else if (Last_materialWndType == 3) {

                    KindsofWidget(last_left,lastGroupId,materialbox_kind);
                }
            }
            
            KindsofWidget(current_right,Id,materialbox_kind);
        }
    }

    showAndHide();
    showAndHide_L();

    QSettings settings2("YourOrganization", "YourApplication_lastWndType");
    settings2.setValue("LastWndType", lastIndex);
    settings2.setValue("LastGroup", lastGroupId);

    QPixmap scaledPixmap_right = newPixmap.scaled(size_right, Qt::KeepAspectRatio, Qt::SmoothTransformation);
    ui->RightOperatewidget->setPixmap(scaledPixmap_right);

    QPixmap scaledPixmap_left = lastRightPixmap.scaled(size_left, Qt::KeepAspectRatio, Qt::SmoothTransformation);
    ui->LeftOperatewidget->setPixmap(scaledPixmap_left);

    // 更新当前图片的成员变量
    // Left_currentPixmap = scaledPixmap_left;
    // Left_scaleFactor = 1.0;
    // Right_currentPixmap = scaledPixmap_right;
    // Right_scaleFactor = 1.0;
    // ui->Leftlabel_Percentage->setText("100%");
    // ui->Rightlabel_Percentage->setText("100%");

    // ui->LeftDataSources->clear();
    // ui->LeftDataSources->addItems(lasttextList);
    // ui->RightDataSources->clear();
    // ui->RightDataSources->addItems(textList);

    // 保存到 QSettings
    // settings.beginGroup("LastSettings");
    // settings.setValue("LastRightPixmap", lastRightPixmap);
    // settings.setValue("LasttextList", lasttextList);
    // settings.setValue("LastLastRightPixmap", lastLastRightPixmap);
    // settings.setValue("LastLasttextList", lastLasttextList);
    // settings.setValue("LastLastIndex", lastLastIndex);
    // settings.setValue("LastLastGroupId", lastLastGroupId);
    // settings.endGroup();

    if (isUpdatingSettings) {
        lastLastRightPixmap = lastRightPixmap;
        lastLasttextList = lasttextList;
        lastRightPixmap = scaledPixmap_right;
        lasttextList = textList;
        lastLastIndex = lastIndex;
        lastLastGroupId = lastGroupId;
    }
}

void MainAndSecondaryCamerasWnd::clearLayout(int flag) {
    QWidget* widget = (flag == 1) ? ui->RightOperatewidget : ui->LeftOperatewidget;
    QLayout* layout = widget->layout();

    if (layout) {
        QLayoutItem *child;
        while ((child = layout->takeAt(0)) != nullptr) {
            if (child->widget() != nullptr) {
                delete child->widget();  // 删除控件
            }
            delete child;  // 删除布局项
        }
        delete layout;  // 删除布局本身
    }
}
//相机
void MainAndSecondaryCamerasWnd::imageWidget(QString path,int flag,QSize size){
    QPixmap newPixmap;
    QPixmap Last_newPixmap;
    if(flag == 0){
        isShow_L = true;
        Last_newPixmap = QPixmap(path);
        QPixmap scaledPixmap = Last_newPixmap.scaled(size, Qt::KeepAspectRatio, Qt::SmoothTransformation);
        Left_currentMode = ModeImage;
        Left_currentPixmap = scaledPixmap;
        Left_scaleFactor = 1.0;
        Left_previousScaleFactor = 1.0;
        ui->LeftOperatewidget->setPixmap(scaledPixmap);
        double percentage = Left_scaleFactor * 100;
        QString percentageStr = QString::number((int)percentage);
        ui->Leftlabel_Percentage->setText(QString("%1%").arg(percentageStr));
        applyScale(0);
    }else if(flag == 1){
        isShow_R = true;
        qDebug()<<path;
        newPixmap = QPixmap(":/images/test_image/image_1.png");
        QPixmap scaledPixmap = newPixmap.scaled(size, Qt::KeepAspectRatio, Qt::SmoothTransformation);
        Right_currentMode = ModeImage;
        Right_currentPixmap = scaledPixmap;
        Right_scaleFactor = 1.0;
        Right_previousScaleFactor = 1.0;
        ui->RightOperatewidget->setPixmap(scaledPixmap);
        double percentage = Right_scaleFactor * 100;
        QString percentageStr = QString::number((int)percentage);
        ui->Rightlabel_Percentage->setText(QString("%1%").arg(percentageStr));
        applyScale(1);

    }else{
        qDebug()<<"parameter has problem";
    }
}

// 圆晶
void MainAndSecondaryCamerasWnd::KindsofWidget(int flag,int groupId,kinds kind) {
    if(flag == 0){

        ui->LeftOperatewidget->clearPixmap();
        QVBoxLayout *layout = new QVBoxLayout(ui->LeftOperatewidget);
        layout->setContentsMargins(0, 0, 0, 0);

        if(kind == wafer_kind){
            waferMap.value(groupId)->initFrom(ui->LeftOperatewidget);
            layout->addWidget(waferMap.value(groupId)->view);
            Left_currentView = waferMap.value(groupId)->view;
        }else if(kind == waffle_kind){
            waffleMap.value(groupId)->initFrom(ui->LeftOperatewidget);
            layout->addWidget(waffleMap.value(groupId)->view);
            Left_currentView = waffleMap.value(groupId)->view;
        }else if(kind == materialbox_kind){
            materialBoxMap.value(groupId)->initFrom(ui->LeftOperatewidget);
            layout->addWidget(materialBoxMap.value(groupId)->view);
            Left_currentView = materialBoxMap.value(groupId)->view;
        }else{

        }

        ui->LeftOperatewidget->setLayout(layout);
        Left_currentMode = ModeView;

        Left_scaleFactor = 1.0;
        applyScale(0);
    }else if(flag == 1){
        ui->RightOperatewidget->clearPixmap();
        QVBoxLayout *layout = new QVBoxLayout(ui->RightOperatewidget);
        layout->setContentsMargins(0, 0, 0, 0);

        if(kind == wafer_kind){
            waferMap.value(groupId)->initFrom(ui->RightOperatewidget);
            layout->addWidget(waferMap.value(groupId)->view);
            Right_currentView = waferMap.value(groupId)->view;
        }else if(kind == waffle_kind){
            waffleMap.value(groupId)->initFrom(ui->RightOperatewidget);
            layout->addWidget(waffleMap.value(groupId)->view);
            Right_currentView = waffleMap.value(groupId)->view;
        }else if(kind == materialbox_kind){
            materialBoxMap.value(groupId)->initFrom(ui->RightOperatewidget);
            layout->addWidget(materialBoxMap.value(groupId)->view);
            Right_currentView = materialBoxMap.value(groupId)->view;
        }else{

        }
        ui->RightOperatewidget->setLayout(layout);
        Right_currentMode = ModeView;
        Right_scaleFactor = 1.0;
        applyScale(1);

    }else{
        qDebug()<<"parameter has problem";
    }
}

// 更新缩放比例
void MainAndSecondaryCamerasWnd::updateScale(double newScaleFactor, int flag) {
    if (flag == 0) {
        if (newScaleFactor >= 1.0) {
            Left_scaleFactor = newScaleFactor;
        } else {
            Left_scaleFactor = 1.0; // 最小缩放比例为 1.0
        }
    } else if (flag == 1) {
        if (newScaleFactor >= 1.0) {
            Right_scaleFactor = newScaleFactor;
        } else {
            Right_scaleFactor = 1.0; // 最小缩放比例为 1.0
        }
    }

    applyScale(flag); // 应用缩放
}

// 应用缩放
void MainAndSecondaryCamerasWnd::applyScale(int flag) {
    if (flag == 0) {
        if (Left_currentMode == ModeImage) {
            // 图片模式：缩放图片
            int newWidth = Left_currentPixmap.width() * Left_scaleFactor;
            int newHeight = Left_currentPixmap.height() * Left_scaleFactor;

            QPixmap scaledImage = Left_currentPixmap.scaled(newWidth, newHeight, Qt::KeepAspectRatio, Qt::SmoothTransformation);
            ui->LeftOperatewidget->setPixmapAndPoint(scaledImage, Left_previousScaleFactor, Left_scaleFactor, mousePos);
            Left_previousScaleFactor = Left_scaleFactor;
        } else if (Left_currentMode == ModeView && Left_currentView) {
            // View 模式：缩放 view
            QTransform transform;
            transform.scale(Left_scaleFactor, Left_scaleFactor);
            Left_currentView->setTransform(transform);
        }

        // 更新百分比显示
        double percentage = Left_scaleFactor * 100;
        QString percentageStr = QString::number((int)percentage);
        ui->Leftlabel_Percentage->setText(QString("%1%").arg(percentageStr));
    } else if (flag == 1) {
        if (Right_currentMode == ModeImage) {
            // 图片模式：缩放图片
            int newWidth = Right_currentPixmap.width() * Right_scaleFactor;
            int newHeight = Right_currentPixmap.height() * Right_scaleFactor;

            QPixmap scaledImage = Right_currentPixmap.scaled(newWidth, newHeight, Qt::KeepAspectRatio, Qt::SmoothTransformation);
            ui->RightOperatewidget->setPixmapAndPoint(scaledImage, Right_previousScaleFactor, Right_scaleFactor, mousePos);
            Right_previousScaleFactor = Right_scaleFactor;
        } else if (Right_currentMode == ModeView && Right_currentView) {
            // View 模式：缩放 view
            QTransform transform;
            transform.scale(Right_scaleFactor, Right_scaleFactor);
            Right_currentView->setTransform(transform);
        }

        // 更新百分比显示
        double percentage = Right_scaleFactor * 100;
        QString percentageStr = QString::number((int)percentage);
        ui->Rightlabel_Percentage->setText(QString("%1%").arg(percentageStr));
    }
}
void MainAndSecondaryCamerasWnd::on_LeftZoomUpButton_clicked()
{
    mousePos = ui->LeftOperatewidget->geometry().center();
    updateScale(Left_scaleFactor * 1.1, 0);

}


void MainAndSecondaryCamerasWnd::on_RightZoomUpButton_clicked()
{
    mousePos = ui->RightOperatewidget->geometry().center();
    updateScale(Right_scaleFactor * 1.1, 1);

}


void MainAndSecondaryCamerasWnd::on_LeftZoomOutButton_clicked()
{
    mousePos = ui->LeftOperatewidget->geometry().center();
    updateScale(Left_scaleFactor * 0.9, 0);

}


void MainAndSecondaryCamerasWnd::on_RightZoomOutButton_clicked()
{
    mousePos = ui->RightOperatewidget->geometry().center();
    updateScale(Right_scaleFactor * 0.9, 1);

}

void MainAndSecondaryCamerasWnd::wheelEvent(QWheelEvent *event)
{
    if (ui->LeftOperatewidget->rect().contains(ui->LeftOperatewidget->mapFromGlobal(event->globalPos()))) {
        mousePos = ui->LeftOperatewidget->mapFromGlobal(event->globalPos());
        if (event->angleDelta().y() > 0) {
            updateScale(Left_scaleFactor * 1.1, 0); // 放大
        } else {
            updateScale(Left_scaleFactor * 0.9, 0); // 缩小
        }
    }

    if (ui->RightOperatewidget->rect().contains(ui->RightOperatewidget->mapFromGlobal(event->globalPos()))) {
        mousePos = ui->RightOperatewidget->mapFromGlobal(event->globalPos());
        if (event->angleDelta().y() > 0) {
            updateScale(Right_scaleFactor * 1.1, 1); // 放大
        } else {
            updateScale(Right_scaleFactor * 0.9, 1); // 缩小
        }
    }
    if (ui->scrollArea->rect().contains(ui->scrollArea->mapFromGlobal(event->globalPos()))) {
        // 获取 QScrollArea 的横向滚动条
        QScrollBar *scrollBar = ui->scrollArea->horizontalScrollBar();
        // 根据滚轮滚动方向改变滚动条的值
        if (event->angleDelta().y() > 0) {
            scrollBar->setValue(scrollBar->value() - 50);
        } else {
            scrollBar->setValue(scrollBar->value() + 50);
        }
    }
    
	QMainWindow::wheelEvent(event);
}

void MainAndSecondaryCamerasWnd::showEvent(QShowEvent *event) {
    isUpdatingSettings = false;
    QMainWindow::showEvent(event);

    loadSettings();
    isUpdatingSettings = true;
}

void MainAndSecondaryCamerasWnd::hideEvent(QHideEvent *event) {
    isUpdatingSettings = false;
    QMainWindow::hideEvent(event);
}

void MainAndSecondaryCamerasWnd::CheckIs()
{
    QSettings settings("YourCompany", "YourApplication_Button");
    int groupId = settings.value("GroupId_button", 0).toInt();

    if (groupId == lastGroupId) {
        if (lastIndex == 1 ) {
            if(isShow_R == true){
                isShow_R = false;
            } else {
                isShow_R = true;
            }
        }
        if (lastLastIndex == 1 && groupId == lastLastGroupId) {
            if(isShow_L == true){
                isShow_L = false;
            } else {
                isShow_L = true;
            }
        }
        showAndHide();
        showAndHide_L();

    } else if (groupId == lastLastGroupId) {
        if (lastLastIndex == 1) {
            if(isShow_L == true){
                isShow_L = false;
            } else {
                isShow_L = true;
            }
        }
        showAndHide_L();
    }
}

void MainAndSecondaryCamerasWnd::showAndHide(){
    QList<QLineEdit*> lineEdits = {
        ui->RedLightlineEdit_2, ui->GreenLightlineEdit_5,
        ui->BlueLightlineEdit_2, ui->DotLightlineEdit_2
    };
    QList<QSlider*> sliders = {
        ui->RedLightverticalSlider_2, ui->GreenLightverticalSlider_5,
        ui->BlueLightverticalSlider, ui->DotLightverticalSlider_2
    };
    QList<QProgressBar*> progressBar = {
        ui->RedLightprogressBar_2,ui->GreenLightprogressBar_5,
        ui->BlueLightprogressBar_2,ui->DotLightprogressBar_2
    };
    if(isShow_R == true){
        for (QLineEdit* lineEdit : lineEdits) {
            lineEdit->show();
        }
        for (int i = 0; i < sliders.size(); ++i) {
            sliders[i]->show();
        }
        for (int i = 0; i < progressBar.size(); ++i) {
            progressBar[i]->show();
        }
        ui->BlueLight->show();
        ui->RedLight->show();
        ui->DotLight->show();
        ui->GreenLight->show();
        ui->BlueLightlabel_2->show();
        ui->RedLightlabel_2->show();
        ui->DotLightlabel_2->show();
        ui->GreenLightlabel_5->show();
    }else{
        for (QLineEdit* lineEdit : lineEdits) {
            lineEdit->hide();
        }
        for (int i = 0; i < sliders.size(); ++i) {
            sliders[i]->hide();
        }
        for (int i = 0; i < progressBar.size(); ++i) {
            progressBar[i]->hide();
        }
        ui->BlueLight->hide();
        ui->RedLight->hide();
        ui->DotLight->hide();
        ui->GreenLight->hide();
        ui->BlueLightlabel_2->hide();
        ui->RedLightlabel_2->hide();
        ui->DotLightlabel_2->hide();
        ui->GreenLightlabel_5->hide();
    }
}

void MainAndSecondaryCamerasWnd::showAndHide_L(){
    QList<QLineEdit*> lineEdits = {
        ui->RedLightlineEdit_L, ui->GreenLightlineEdit_L,
        ui->BlueLightlineEdit_L, ui->DotLightlineEdit_L
    };
    QList<QSlider*> sliders = {
        ui->RedLightverticalSlider_L, ui->GreenLightverticalSlider_L,
        ui->BlueLightverticalSlider_L, ui->DotLightverticalSlider_L
    };
    QList<QProgressBar*> progressBar = {
        ui->RedLightprogressBar_L,ui->GreenLightprogressBar_L,
        ui->BlueLightprogressBar_L,ui->DotLightprogressBar_L
    };
    if(isShow_L == true){
        for (QLineEdit* lineEdit : lineEdits) {
            lineEdit->show();
        }
        for (int i = 0; i < sliders.size(); ++i) {
            sliders[i]->show();
        }
        for (int i = 0; i < progressBar.size(); ++i) {
            progressBar[i]->show();
        }
        ui->BlueLight_L->show();
        ui->RedLight_L->show();
        ui->DotLight_L->show();
        ui->GreenLight_L->show();/*
        ui->BlueLightlabel_2->show();
        ui->RedLightlabel_2->show();
        ui->DotLightlabel_2->show();
        ui->GreenLightlabel_5->show();*/
    }else{
        for (QLineEdit* lineEdit : lineEdits) {
            lineEdit->hide();
        }
        for (int i = 0; i < sliders.size(); ++i) {
            sliders[i]->hide();
        }
        for (int i = 0; i < progressBar.size(); ++i) {
            progressBar[i]->hide();
        }
        ui->BlueLight_L->hide();
        ui->RedLight_L->hide();
        ui->DotLight_L->hide();
        ui->GreenLight_L->hide();
        // ui->BlueLightlabel_2->hide();
        // ui->RedLightlabel_2->hide();
        // ui->DotLightlabel_2->hide();
        // ui->GreenLightlabel_5->hide();
    }
}


